#!/usr/bin/ruby
# $Id: wikipub.rb 253 2010-12-28 19:24:17Z briane $

require "./htmlscanner.rb"
require "./htmlparser.rb"
require "./epubgen.rb"
require 'cgi'

epub_gen = EpubGen.new
html_parser = HtmlParser.new
html_scanner = HtmlScanner.new
if ARGV.length != 1
    print "Put path to cablegate folder on the command line.\n" + 
        "(This is the folder that contains subfolders like 'articles', 'cable', \n" + 
        "'static', and 'tag'.)\n" + 
        "For example:   ./wikipub.rb ~/Desktop/cablegate-201012081414\n"
    exit 1
end
html_scanner.ScanFolder ARGV[0]
throttle = 0
counter = 0
while html_scanner.MoreParsingAvailable?
    data = html_scanner.GetNextFile
    if nil == data
        print "Error, got nil back from GetNextFile\n"
        break
    end
    print "Processing #{html_scanner.GetCurrentCount} of #{html_scanner.GetTotalCount}, #{data.original_filename}\n"
    html_parser.Parse(data)
    #data.DebugDump
    # "title" actually holds escaped HTML, which is okay since we're going to 
    # be writing it to an index.  To briefly display to user, unescape it to make
    # it a bit more pretty.
    print "   \"#{CGI::unescapeHTML(data.title)}\", #{data.html_content.length} bytes\n"
    epub_gen.AddSection(data)
    counter += 1
    if throttle > 0 && counter >= throttle
        break
    end
end
print "Writing metadata"
epub_gen.WriteMetadata()
print "Creating archive"
epub_gen.Compress()
